////////////////////////////////////////////////////////////////////////////////
// MAIN.C - BBamp - WinAmp Controller Program       by Athlor (athlor@gmail.com)
////////////////////////////////////////////////////////////////////////////////
#include <pager.h>
#include <ribbon.h>
#include <led.h>
#include "gfx.h"
#define TIMER_EVENT 0x40001

char VersionPtr[] = "BBamp";
int AppStackSize = 3000;

int Kscope(MESSAGE *Msg)
{
  char w=rand()%80, h=rand()%45, x=rand()%(81-w), y=rand()%(46-h);
  LcdRasterOp(INVERT_DEST,w,h,NULL,0,0,NULL,x,54+y);          // Upper left
  LcdRasterOp(INVERT_DEST,w,h,NULL,0,0,NULL,160-x-w,54+y);    // Upper right
  LcdRasterOp(INVERT_DEST,w,h,NULL,0,0,NULL,x,144-y-h);       // Lower left
  LcdRasterOp(INVERT_DEST,w,h,NULL,0,0,NULL,160-x-w,144-y-h); // Lower right
  return FALSE; // Msg not forwarded
}

void BBampThread(void)
{
  char c,l,mode=0,s[99],mnu=0; // char, len, mode, string, menu
  char *cmd = "zpxsnvcbmfr";   // WinAmp output commands
  MESSAGE MSG, newMsg;
  PID Pid; Pid.EnableForeground=TRUE;
  Pid.Name=VersionPtr; Pid.Icon=NULL;
  RimSetPID(&Pid);
  srand(RimGetTicks());        // Seed rand
  CommOpenPort(9600,8,COMM_NO_PARITY,1,2048,2048);
  RimSetTimer(TIMER_EVENT, 50, TIMER_PERIODIC); // Set period (100th/sec)
  RimRegisterMessageCallback(TIMER_EVENT, 0xffffffff, Kscope);

  for (;;) // Start message loop
  {
    LcdCopyBitmapToDisplay(&menu,0,145); // Draw Menu
    LcdDrawBox(DRAW_BLACK,0,0,159,52);   // Box around song info

    LcdRasterOp(INVERT_DEST,12,12,NULL,0,0,NULL,mnu*14+4,146); // SELECT
    RimGetMessage(&MSG);
    LcdRasterOp(INVERT_DEST,12,12,NULL,0,0,NULL,mnu*14+4,146); // DESELECT

    switch (MSG.Device)
    {
      case DEVICE_KEYPAD:
        switch (MSG.Event)
        {
          case THUMB_ROLL_UP:   if(mnu>0)  mnu--; break; // Menu left
          case THUMB_ROLL_DOWN: if(mnu<10) mnu++; break; // Menu right
          case KEY_DOWN:
          {
            switch (MSG.SubMsg)
            {
              case KEY_ESCAPE: // ESC key exits
                CommClosePort();
                RimKillTimer(TIMER_EVENT);
                RimRegisterMessageCallback(TIMER_EVENT,0xffffffff,NULL);
                RibbonShowRibbon();
                RimTerminateThread();
                break;
            }
            break;
          }
        } // End (MSG.Event)
        break;
      case DEVICE_COM1:
        if (MSG.Event==COMM_RX_AVAILABLE)
        {
          c=CommReadChar();
          if(c=='[') { // Read mode ON
            mode=1; l=0;
            RimSetLed(LED_MESSAGE,LED_ON); // Turn LED ON
          }
          else if(mode==1) {
            if(c=='-') {c='\n';    // Replace - with newline
              if(s[l-1]==' ') l--; // Backup if last char was space
            }
            s[l++]=c;
            if(c==']') { // Read mode OFF
              s[--l]=0; mode=0;

              // Backlight code (doesn't work)   
              newMsg.Device = DEVICE_KEYPAD; // ATTEMPT TO TURN ON BACKLIGHT
              newMsg.Event = KEY_DOWN;       // TRYED KEY_UP & KEY_STATUS too!
              newMsg.SubMsg = KEY_BKLITE;
              RimPostMessage(RimGetForegroundApp(),&newMsg); // FAKE KEY PRESS

              LcdRasterOp(WHITE,158,50,NULL,0,0,NULL,1,1);   // Clear title area
              LcdSetCurrentFont(FONT_10_PIXEL);
              LcdPutStringXY(-1,2,s,-1,LCD_MULTILINE|LCD_CENTERED); // Song
              LcdRasterOp(WHITE,160,92,NULL,0,0,NULL,0,53); // Clear Kscope
              RimSetLed(LED_MESSAGE,LED_OFF); // Turn LED OFF
            }
          }
          else RimSpeakerBeep(220+c,50,50,49); // ERROR, some odd data found!
        }
    } // End (MSG.Device)
    if(MSG.Event==THUMB_CLICK) {     // I put this here because when it was in
      CommSendChar(cmd[mnu]);        // the Msg.Event SWITCH it would generate
      RimSpeakerBeep(440,50,50,25);  // code causing a page fault !??! VERY ODD!
    }                                // It's happened once before w/ THUMB_CLICK
  }   // Message loop
}

void PagerMain(void)
{
  RibbonRegisterFunction(VersionPtr,&icon,0,40,BBampThread,AppStackSize);
}
